/* ----------------------------------------------------------------------------
  ex16.h
  mbwall 5may95
  Copyright 1995 Massachusetts Institute of Technology

DESCRIPTION:
  Define a point object for use in the example code.
---------------------------------------------------------------------------- */
#ifndef _ex16_h_
#define _ex16_h_

class Point {
public:
  Point(float x, float y, float z){
    _x = x; _y = y; _z = z;
  }
  Point(const Point & p){
    _x = p._x; _y = p._y; _z = p._z;
  }
  Point & operator=(const Point & p){
    _x = p._x; _y = p._y; _z = p._z;
    return *this;
  }
  ~Point(){}

  float x() const {return _x;}
  float y() const {return _y;}
  float z() const {return _z;}
  float x(float val){return _x=val;}
  float y(float val){return _y=val;}
  float z(float val){return _z=val;}

  friend ostream & operator<<(ostream & os, const Point & p){
    os << "(" << p._x << ", " << p._y << ", " << p._z << ")";
    return os;
  }

protected:
  float _x, _y, _z;
};

#endif
