// $Header: /usr/people/mbwall/src/ga/ga/RCS/array2.xs.C,v 1.1 1995/06/30 21:27:55 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  array2.xs.C
  mbwall 25feb95
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
  This header defines the interface for the 2D array genome crossover sites.

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#include <ga/array2.xs.h>

template <class T> void
GA2DArray1PtCrossSite<T>::pick(GAGenome & c){
  GA2DArrayGenome<T> & m = (GA2DArrayGenome<T> &)c;
  x = GARandomInt(0, m.width());  x1 = x2 = gaNoSite;
  y = GARandomInt(0, m.height()); y1 = y2 = gaNoSite;
}

template <class T> void
GA2DArray1PtCrossSite<T>::
pick(GAGenome & c, const GAGenome & c1, const GAGenome & c2){
  GA2DArrayGenome<T> & m  = (GA2DArrayGenome<T> &)c;
  GA2DArrayGenome<T> & mom = (GA2DArrayGenome<T> &)c1;
  GA2DArrayGenome<T> & dad = (GA2DArrayGenome<T> &)c2;
  x  = GARandomInt(0, m.width());
  x1 = GARandomInt(0, mom.width());
  x2 = GARandomInt(0, dad.width());
  y  = GARandomInt(0, m.height());
  y1 = GARandomInt(0, mom.height());
  y2 = GARandomInt(0, dad.height());
}

template <class T> void
GA2DArray1PtCrossSite<T>::mirror(GAGenome &, const GAGenome & c1){
  x  = ((GA2DArray1PtCrossSite<T> &)(c1.crossoverSite())).x;
  x1 = ((GA2DArray1PtCrossSite<T> &)(c1.crossoverSite())).x2;
  x2 = ((GA2DArray1PtCrossSite<T> &)(c1.crossoverSite())).x1;
  y  = ((GA2DArray1PtCrossSite<T> &)(c1.crossoverSite())).y;
  y1 = ((GA2DArray1PtCrossSite<T> &)(c1.crossoverSite())).y2;
  y2 = ((GA2DArray1PtCrossSite<T> &)(c1.crossoverSite())).y1;
}
