// $Header: /usr/people/mbwall/src/ga/ga/RCS/array2.xs.h,v 1.2 1995/07/11 20:35:22 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  array2.xs.h
  mbwall 25feb95
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
  This header defines the interface for the 2D array genome crossover sites.

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#ifndef _ga_array2_xs_h_
#define _ga_array2_xs_h_

#include <ga/xsite.h>

/* ----------------------------------------------------------------------------
 2D Array Single Point Crossover
---------------------------------------------------------------------------- */
template <class T>
class GA2DArray1PtCrossSite : public GACrossSite {
  GADefineIdentity("GA2DArray1PtCrossSite", 88):

public:
  GA2DArray1PtCrossSite(){x=x1=x2=gaNoSite; y=y1=y2=gaNoSite;}
  GA2DArray1PtCrossSite(int a, int b){x=x1=x2=a; y=y1=y2=b;}
  GA2DArray1PtCrossSite(const GA2DArray1PtCrossSite<T> & orig){copy(orig);}
  GA2DArray1PtCrossSite<T> & operator=(const GACrossSite & orig)
    {copy(orig); return *this;}
  GA2DArray1PtCrossSite<T> & operator=(const GA2DArray1PtCrossSite<T> & orig)
    {copy(orig); return *this;}
  virtual ~GA2DArray1PtCrossSite(){}
  virtual void copy(const GACrossSite & xs){
    if(&xs == this || !sameClass(xs)) return;
    GA2DArray1PtCrossSite<T> & orig = (GA2DArray1PtCrossSite<T> &)xs;
    x=orig.x; x1=orig.x1; x2=orig.x2;
    y=orig.y; y1=orig.y1; y2=orig.y2;
  }
  virtual GACrossSite * clone() const
    {return new GA2DArray1PtCrossSite<T>(*this);}

  virtual void pick(GAGenome &);
  virtual void pick(GAGenome &, const GACrossSite & s){copy(s);}
  virtual void pick(GAGenome &, const GAGenome&, const GAGenome&);
  virtual void mirror(GAGenome &, const GAGenome &);
  int x, x1, x2;
  int y, y1, y2;
};

#ifdef BORLAND_INST
#include <ga/array2.xs.C>
#endif

#endif

