// $Header: /usr/people/mbwall/src/ga/ga/RCS/array3.xs.C,v 1.1 1995/06/30 21:27:55 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  array3.xs.C
  mbwall 25feb95
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
  This header defines the interface for the 3D array genome crossover sites.

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#include <ga/array3.xs.h>


template <class T> void
GA3DArray1PtCrossSite<T>::pick(GAGenome & c){
  GA3DArrayGenome<T> & m = (GA3DArrayGenome<T> &)c;
  x = GARandomInt(0, m.width());  x1 = x2 = gaNoSite;
  y = GARandomInt(0, m.height()); y1 = y2 = gaNoSite;
  z = GARandomInt(0, m.depth());  z1 = z2 = gaNoSite;
}

template <class T> void
GA3DArray1PtCrossSite<T>::
pick(GAGenome & c, const GAGenome & c1, const GAGenome & c2){
  GA3DArrayGenome<T> & m  = (GA3DArrayGenome<T> &)c;
  GA3DArrayGenome<T> & mom = (GA3DArrayGenome<T> &)c1;
  GA3DArrayGenome<T> & dad = (GA3DArrayGenome<T> &)c2;
  x  = GARandomInt(0, m.width());
  x1 = GARandomInt(0, mom.width());
  x2 = GARandomInt(0, dad.width());
  y  = GARandomInt(0, m.height());
  y1 = GARandomInt(0, mom.height());
  y2 = GARandomInt(0, dad.height());
  z  = GARandomInt(0, m.depth());
  z1 = GARandomInt(0, mom.depth());
  z2 = GARandomInt(0, dad.depth());
}

template <class T> void
GA3DArray1PtCrossSite<T>::mirror(GAGenome &, const GAGenome & c1){
  x  = ((GA3DArray1PtCrossSite<T> &)(c1.crossoverSite())).x;
  x1 = ((GA3DArray1PtCrossSite<T> &)(c1.crossoverSite())).x2;
  x2 = ((GA3DArray1PtCrossSite<T> &)(c1.crossoverSite())).x1;
  y  = ((GA3DArray1PtCrossSite<T> &)(c1.crossoverSite())).y;
  y1 = ((GA3DArray1PtCrossSite<T> &)(c1.crossoverSite())).y2;
  y2 = ((GA3DArray1PtCrossSite<T> &)(c1.crossoverSite())).y1;
  z  = ((GA3DArray1PtCrossSite<T> &)(c1.crossoverSite())).z;
  z1 = ((GA3DArray1PtCrossSite<T> &)(c1.crossoverSite())).z2;
  z2 = ((GA3DArray1PtCrossSite<T> &)(c1.crossoverSite())).z1;
}
