// $Header: /usr/people/mbwall/src/ga/ga/RCS/array3.xs.h,v 1.2 1995/07/11 20:35:22 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  array3.xs.h
  mbwall 25feb95
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
  This header defines the interface for the 3D array genome crossover sites.

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#ifndef _ga_array3_xs_h_
#define _ga_array3_xs_h_

#include <ga/xsite.h>

/* ----------------------------------------------------------------------------
 3D Array Single Point Crossover
---------------------------------------------------------------------------- */
template <class T>
class GA3DArray1PtCrossSite : public GACrossSite {
  GADefineIdentity("GA3DArray1PtCrossSite", 90):

public:
  GA3DArray1PtCrossSite()
    {x=x1=x2=gaNoSite; y=y1=y2=gaNoSite; z=z1=z2=gaNoSite;}
  GA3DArray1PtCrossSite(int a, int b, int c)
    {x=x1=x2=a; y=y1=y2=b; z=z1=z2=c;}
  GA3DArray1PtCrossSite(const GA3DArray1PtCrossSite<T> & orig){copy(orig);}
  GA3DArray1PtCrossSite<T> & operator=(const GACrossSite & orig)
    {copy(orig); return *this;}
  GA3DArray1PtCrossSite<T> & operator=(const GA3DArray1PtCrossSite<T> & orig)
    {copy(orig); return *this;}
  virtual ~GA3DArray1PtCrossSite(){}
  virtual void copy(const GACrossSite & xs){
    if(&xs == this || !sameClass(xs)) return;
    GA3DArray1PtCrossSite<T> & orig = (GA3DArray1PtCrossSite<T> &)xs;
    x=orig.x; x1=orig.x1; x2=orig.x2;
    y=orig.y; y1=orig.y1; y2=orig.y2;
    z=orig.z; z1=orig.z1; z2=orig.z2;
  }
  virtual GACrossSite * clone() const
    {return new GA3DArray1PtCrossSite<T>(*this);}

  virtual void pick(GAGenome &);
  virtual void pick(GAGenome &, const GACrossSite & s){copy(s);}
  virtual void pick(GAGenome &, const GAGenome&, const GAGenome&);
  virtual void mirror(GAGenome &, const GAGenome &);
  int x, x1, x2;
  int y, y1, y2;
  int z, z1, z2;
};

#ifdef BORLAND_INST
#include <ga/array3.xs.C>
#endif

#endif
