// $Header: /usr/people/mbwall/src/ga/ga/RCS/bin2dec.h,v 1.2 1995/09/13 22:30:10 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  bin2dec.h
  mbwall 29jun95
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
  Header for the binary to decimal conversion routines.  Eventually this will
all get rolled into the binary string object, but for now we'll do it this way.
This code was formerly in utilities.h

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#ifndef _ga_bin2dec_h_
#define _ga_bin2dec_h_

// The type for the bin2dec and dec2bin bit representation (until we implement
// a proper bitstream object).
typedef unsigned char GABit;


// These numbers are machine-specific and are a function of the word length of
// the OS you are running.  The binary string cannot be too long or else we 
// can't represent it with a float.
#ifndef BITS_IN_LONG
#define BITS_IN_LONG 32
#endif
#define _GA_MAX_BITS          BITS_IN_LONG	// number of bits in a long int


float GABin2Dec(const char *);
float GABin2Dec(const char *, const unsigned int);
float GABin2Dec(const char *, const unsigned int, const float, const float);

float GABin2Dec(const GABit *, const unsigned int);
float GABin2Dec(const GABit *, const unsigned int, const float, const float);

float GADec2Bin(const unsigned long int, GABit *, const unsigned int);
float GADec2Bin(const float, GABit *, const unsigned int,
                const float, const float);

#endif
