// $Header: /usr/people/mbwall/src/ga/ga/RCS/bin2dec.ph.h,v 1.2 1995/07/11 20:35:22 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  bin2dec.ph.h
  mbwall 14aug94
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
   This header defines the phenotype objects used for the default phenotypes
for the GA library.  These are defined so that you don't have to write them
yourself.  We'll incorporate into the library any phenotypes that are common
enough to warrant their inclusion.

 TO DO:
  binary to integer phenotype?

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#ifndef _ga_bin2dec_ph_h_
#define _ga_bin2dec_ph_h_

class GABin2DecPhenotype {
public:
  GABin2DecPhenotype();
  GABin2DecPhenotype(const GABin2DecPhenotype & arg){copy(arg);}
  GABin2DecPhenotype & operator=(const GABin2DecPhenotype & arg)
    {copy(arg); return(*this);}
  virtual ~GABin2DecPhenotype();
  void copy(const GABin2DecPhenotype & arg);
  GABin2DecPhenotype * clone() const {return new GABin2DecPhenotype(*this);}

  friend int operator==(const GABin2DecPhenotype&, const GABin2DecPhenotype&);
  friend int operator!=(const GABin2DecPhenotype&, const GABin2DecPhenotype&);

  void add(const unsigned int nbits, const float min, const float max);
  void remove(const unsigned int which);
  int size() const {return sz;}
  int nPhenotypes() const {return n;}
  float min(const int which) const {return minval[which];}
  float max(const int which) const {return maxval[which];}
  int length(const int which) const {return nbits[which];}
  int offset(const int which) const {return oset[which];}

  int chunksize() const {return csz;}
  int chunksize(const unsigned int csize){return csz=csize;}
  void compact();

protected:
  unsigned int csz;		// how big are the chunks we allocate?
  unsigned int n, N;		// how many phenotypes do we have? (real,alloc)
  unsigned short *nbits;	// number of bits that max/min get mapped into
  unsigned short *oset;		// offset of the nth gene
  float *minval, *maxval;	// min, max, and actual value of phenotype elem
  unsigned int sz;		// total number of bits required
};

#endif
