// $Header: /usr/people/mbwall/src/ga/ga/RCS/binstr1.xs.C,v 1.1 1995/06/30 21:27:55 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  binstr1.xs.C
  mbwall 19apr95
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
  Source file for the 1D binary string genome crossover sites.

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#include <ga/random.h>
#include <ga/binstr1.xs.h>
#include <ga/binstr1.ch.h>


#if USE_1PT_CROSSOVER == 1
/* ----------------------------------------------------------------------------
1D Binary String Single Point Crossover Site
---------------------------------------------------------------------------- */
void
GA1DBinStr1PtCrossSite::pick(GAGenome & c){
  GA1DBinaryStringGenome & m = (GA1DBinaryStringGenome &)c;
  x = GARandomInt(0, m.length()); x1 = x2 = gaNoSite;
}

void
GA1DBinStr1PtCrossSite::
pick(GAGenome & c, const GAGenome & c1, const GAGenome & c2){
  GA1DBinaryStringGenome & m  = (GA1DBinaryStringGenome &)c;
  GA1DBinaryStringGenome & mom = (GA1DBinaryStringGenome &)c1;
  GA1DBinaryStringGenome & dad = (GA1DBinaryStringGenome &)c2;
  x  = GARandomInt(0, m.length());
  x1 = GARandomInt(0, mom.length());
  x2 = GARandomInt(0, dad.length());
}

void
GA1DBinStr1PtCrossSite::mirror(GAGenome &, const GAGenome & c1){
  x  = ((GA1DBinStr1PtCrossSite &)(c1.crossoverSite())).x;
  x1 = ((GA1DBinStr1PtCrossSite &)(c1.crossoverSite())).x2;
  x2 = ((GA1DBinStr1PtCrossSite &)(c1.crossoverSite())).x1;
}
#endif


#if USE_2PT_CROSSOVER == 1
/* ----------------------------------------------------------------------------
1D Binary String Two Point Crossover Site
---------------------------------------------------------------------------- */
void
GA1DBinStr2PtCrossSite::pick(GAGenome & c){
  GA1DBinaryStringGenome & m = (GA1DBinaryStringGenome &)c;
  x[0] = GARandomInt(0, m.length()); x1[0] = x2[0] = gaNoSite;
  x[1] = GARandomInt(0, m.length()); x1[1] = x2[1] = gaNoSite;
  if(x[1] < x[0]){int tmp=x[0]; x[0]=x[1]; x[1]=tmp;}
}

void
GA1DBinStr2PtCrossSite::
pick(GAGenome & c, const GAGenome & c1, const GAGenome & c2){
  GA1DBinaryStringGenome & m  = (GA1DBinaryStringGenome &)c;
  GA1DBinaryStringGenome & mom = (GA1DBinaryStringGenome &)c1;
  GA1DBinaryStringGenome & dad = (GA1DBinaryStringGenome &)c2;
  x[0]  = GARandomInt(0, m.length());
  x[1]  = GARandomInt(0, m.length());
  if(x[1] < x[0]){int tmp=x[0]; x[0]=x[1]; x[1]=tmp;}
  x1[0] = GARandomInt(0, mom.length());
  x1[1] = GARandomInt(0, mom.length());
  if(x1[1] < x1[0]){int tmp=x1[0]; x1[0]=x1[1]; x1[1]=tmp;}
  x2[0] = GARandomInt(0, dad.length());
  x2[1] = GARandomInt(0, dad.length());
  if(x2[1] < x2[0]){int tmp=x2[0]; x2[0]=x2[1]; x2[1]=tmp;}
}

void
GA1DBinStr2PtCrossSite::mirror(GAGenome &, const GAGenome & c1){
  x[0]  = ((GA1DBinStr2PtCrossSite &)(c1.crossoverSite())).x[0];
  x1[0] = ((GA1DBinStr2PtCrossSite &)(c1.crossoverSite())).x2[0];
  x2[0] = ((GA1DBinStr2PtCrossSite &)(c1.crossoverSite())).x1[0];
  x[1]  = ((GA1DBinStr2PtCrossSite &)(c1.crossoverSite())).x[1];
  x1[1] = ((GA1DBinStr2PtCrossSite &)(c1.crossoverSite())).x2[1];
  x2[1] = ((GA1DBinStr2PtCrossSite &)(c1.crossoverSite())).x1[1];
}
#endif

