// $Header: /usr/people/mbwall/src/ga/ga/RCS/binstr2.xs.C,v 1.1 1995/06/30 21:27:55 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  binstr2.xs.C
  mbwall 19apr95
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
  Source file for the 2D binary string genome crossover sites.

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#include <ga/random.h>
#include <ga/binstr2.xs.h>
#include <ga/binstr2.ch.h>


/* ----------------------------------------------------------------------------
2D Binary String Single Point Crossover Site
---------------------------------------------------------------------------- */
void
GA2DBinStr1PtCrossSite::pick(GAGenome & c){
  GA2DBinaryStringGenome & m = (GA2DBinaryStringGenome &)c;
  x = GARandomInt(0, m.width());  x1 = x2 = gaNoSite;
  y = GARandomInt(0, m.height()); y1 = y2 = gaNoSite;
}

void
GA2DBinStr1PtCrossSite::
pick(GAGenome & c, const GAGenome & c1, const GAGenome & c2){
  GA2DBinaryStringGenome & m  = (GA2DBinaryStringGenome &)c;
  GA2DBinaryStringGenome & mom = (GA2DBinaryStringGenome &)c1;
  GA2DBinaryStringGenome & dad = (GA2DBinaryStringGenome &)c2;
  x  = GARandomInt(0, m.width());
  x1 = GARandomInt(0, mom.width());
  x2 = GARandomInt(0, dad.width());
  y  = GARandomInt(0, m.height());
  y1 = GARandomInt(0, mom.height());
  y2 = GARandomInt(0, dad.height());
}

void
GA2DBinStr1PtCrossSite::mirror(GAGenome &, const GAGenome & c1){
  x  = ((GA2DBinStr1PtCrossSite &)(c1.crossoverSite())).x;
  x1 = ((GA2DBinStr1PtCrossSite &)(c1.crossoverSite())).x2;
  x2 = ((GA2DBinStr1PtCrossSite &)(c1.crossoverSite())).x1;
  y  = ((GA2DBinStr1PtCrossSite &)(c1.crossoverSite())).y;
  y1 = ((GA2DBinStr1PtCrossSite &)(c1.crossoverSite())).y2;
  y2 = ((GA2DBinStr1PtCrossSite &)(c1.crossoverSite())).y1;
}
