// $Header: /usr/people/mbwall/src/ga/ga/RCS/binstr2.xs.h,v 1.1 1995/06/30 21:27:55 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  binstr2.xs.h
  mbwall 19apr95
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
  This header defines the 2D binary string genome crossover sites.

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#ifndef _ga_binstr2_xs_h_
#define _ga_binstr2_xs_h_

#include <ga/xsite.h>


/* ----------------------------------------------------------------------------
 2D Binary String Single Point Crossover
---------------------------------------------------------------------------- */
class GA2DBinStr1PtCrossSite : public GACrossSite {
  GADefineIdentity("GA2DBinStr1PtCrossSite", 78):

public:
  GA2DBinStr1PtCrossSite(){x=x1=x2=y=y1=y2=gaNoSite;}
  GA2DBinStr1PtCrossSite(int a, int b){x=x1=x2=a; y=y1=y2=b;}
  GA2DBinStr1PtCrossSite(const GA2DBinStr1PtCrossSite & orig){copy(orig);}
  GA2DBinStr1PtCrossSite & operator=(const GACrossSite & orig)
    {copy(orig); return *this;}
  GA2DBinStr1PtCrossSite & operator=(const GA2DBinStr1PtCrossSite & orig)
    {copy(orig); return *this;}
  virtual ~GA2DBinStr1PtCrossSite(){}
  virtual void copy(const GACrossSite & xs){
    if(&xs != this && sameClass(xs)){
      GA2DBinStr1PtCrossSite & orig = (GA2DBinStr1PtCrossSite &)xs;
      x=orig.x; x1=orig.x1; x2=orig.x2;
      y=orig.y; y1=orig.y1; y2=orig.y2;
    }
  }
  virtual GACrossSite * clone() const 
    {return new GA2DBinStr1PtCrossSite(*this);}

  virtual void pick(GAGenome &);
  virtual void pick(GAGenome &, const GACrossSite & s){copy(s);}
  virtual void pick(GAGenome &, const GAGenome&, const GAGenome&);
  virtual void mirror(GAGenome &, const GAGenome &);
  int x, y;
  int x1, y1, x2, y2;
};

#endif
