// $Header: /usr/people/mbwall/src/ga/ga/RCS/binstr3.xs.C,v 1.1 1995/06/30 21:27:55 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  binstr3.xs.C
  mbwall 19apr95
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
  Source file for the 3D binary string genome crossover sites.

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#include <ga/random.h>
#include <ga/binstr3.xs.h>
#include <ga/binstr3.ch.h>


/* ----------------------------------------------------------------------------
3D Binary String Single Point Crossover Site
---------------------------------------------------------------------------- */
void
GA3DBinStr1PtCrossSite::pick(GAGenome & c){
  GA3DBinaryStringGenome & m = (GA3DBinaryStringGenome &)c;
  x = GARandomInt(0, m.width());  x1 = x2 = gaNoSite;
  y = GARandomInt(0, m.height()); y1 = y2 = gaNoSite;
  z = GARandomInt(0, m.depth());  z1 = z2 = gaNoSite;
}

void
GA3DBinStr1PtCrossSite::
pick(GAGenome & c, const GAGenome & c1, const GAGenome & c2){
  GA3DBinaryStringGenome & m  = (GA3DBinaryStringGenome &)c;
  GA3DBinaryStringGenome & mom = (GA3DBinaryStringGenome &)c1;
  GA3DBinaryStringGenome & dad = (GA3DBinaryStringGenome &)c2;
  x  = GARandomInt(0, m.width());
  x1 = GARandomInt(0, mom.width());
  x2 = GARandomInt(0, dad.width());
  y  = GARandomInt(0, m.height());
  y1 = GARandomInt(0, mom.height());
  y2 = GARandomInt(0, dad.height());
  z  = GARandomInt(0, m.depth());
  z1 = GARandomInt(0, mom.depth());
  z2 = GARandomInt(0, dad.depth());
}

void
GA3DBinStr1PtCrossSite::mirror(GAGenome &, const GAGenome & c1){
  x  = ((GA3DBinStr1PtCrossSite &)(c1.crossoverSite())).x;
  x1 = ((GA3DBinStr1PtCrossSite &)(c1.crossoverSite())).x2;
  x2 = ((GA3DBinStr1PtCrossSite &)(c1.crossoverSite())).x1;
  y  = ((GA3DBinStr1PtCrossSite &)(c1.crossoverSite())).y;
  y1 = ((GA3DBinStr1PtCrossSite &)(c1.crossoverSite())).y2;
  y2 = ((GA3DBinStr1PtCrossSite &)(c1.crossoverSite())).y1;
  z  = ((GA3DBinStr1PtCrossSite &)(c1.crossoverSite())).z;
  z1 = ((GA3DBinStr1PtCrossSite &)(c1.crossoverSite())).z2;
  z2 = ((GA3DBinStr1PtCrossSite &)(c1.crossoverSite())).z1;
}
