// $Header: /usr/people/mbwall/src/ga/ga/RCS/binstr3.xs.h,v 1.1 1995/06/30 21:27:55 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  binstr3.xs.h
  mbwall 19apr95
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
  This header defines the 3D binary string genome crossover sites.

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#ifndef _ga_binstr3_xs_h_
#define _ga_binstr3_xs_h_

#include <ga/xsite.h>

/* ----------------------------------------------------------------------------
 3D Binary String Single Point Crossover
---------------------------------------------------------------------------- */
class GA3DBinStr1PtCrossSite : public GACrossSite {
  GADefineIdentity("GA3DBinStr1PtCrossSite", 80):

public:
  GA3DBinStr1PtCrossSite(){x=x1=x2=y=y1=y2=z=z1=z2=gaNoSite;}
  GA3DBinStr1PtCrossSite(int a, int b, int c){x=x1=x2=a; y=y1=y2=b; z=z1=z2=c;}
  GA3DBinStr1PtCrossSite(const GA3DBinStr1PtCrossSite & orig){copy(orig);}
  GA3DBinStr1PtCrossSite & operator=(const GACrossSite & orig)
    {copy(orig); return *this;}
  GA3DBinStr1PtCrossSite & operator=(const GA3DBinStr1PtCrossSite & orig)
    {copy(orig); return *this;}
  virtual ~GA3DBinStr1PtCrossSite(){}
  virtual void copy(const GACrossSite & xs){
    if(&xs != this && sameClass(xs)){
      GA3DBinStr1PtCrossSite & orig = (GA3DBinStr1PtCrossSite &)xs;
      x=orig.x; x1=orig.x1; x2=orig.x2;
      y=orig.y; y1=orig.y1; y2=orig.y2;
      z=orig.z; z1=orig.z1; z2=orig.z2;
    } 
  }
  virtual GACrossSite * clone() const 
    {return new GA3DBinStr1PtCrossSite(*this);}

  virtual void pick(GAGenome &);
  virtual void pick(GAGenome &, const GACrossSite & s){copy(s);}
  virtual void pick(GAGenome &, const GAGenome&, const GAGenome&);
  virtual void mirror(GAGenome &, const GAGenome &);
  int x, y, z;
  int x1, y1, z1, x2, y2, z2;
};

#endif
