// $Header: /usr/people/mbwall/src/ga/ga/RCS/error.C,v 1.5 1995/09/13 22:30:10 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  error.C
  mbwall 28jul94
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
  This file contains all of the error messages for the library.

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#include <ga/error.h>

char *gaErrStr[] = {
  "error reading from file: ",
  "error writing to file: ",
  "unexpected EOF encountered during read.",
  "bad probability value.  Must be between 0.0 and 1.0 inclusive.",
  "objects are different types.",

  "warning!  this ga has no replacemnt function",
  "the custom replacement strategy requires a replacement function",
  "unknown replacement strategy",
  "number of children must be greater than 0",
  "replacement percentage is too low - no individuals will be generated",

  "parents are different sizes.",
  "size of child does not match size of parent(s).",
  "genomes cannot be resizable",
  "upper limit must be greater than lower limit.",
  "bad phenotype ID.  value is out of bounds.",
  "bad phenotype value.  value is less than min or greater than max.",
  "no initialization method defined.",
  "no mutation operator defined.",
  "no crossover operator defined.",
  "no operator== method defined.",
  "no operator!= method defined.",
  "no read method defined.",
  "no write method defined.",
  "no clone contents method defined.",
  "no clone attributes method defined.",
  "no pick method defined",
  "no mirror method defined",

  "linear scaling multiplier must be greater than 1.0",
  "sigma truncation multiplier must be greater than 0.0",
  "negative objective function score!\n\
linear scaling requires that all objective function values be positive.",
  "negative objective function score!\n\
power law scaling requires that all objective function values be positive.",

  "length of binary string exceeds float range.",
  "specified value cannot be exactly represented with these bits."
};

void 
GAErr(const char *clss, const char *func,
      const char *msg1, const char *msg2, const char *msg3){
  cerr << clss << ":\n  " << func << ": " << msg1 << "\n";
  if(msg2) cerr << "  " << msg2 << "\n";
  if(msg3) cerr << "  " << msg3 << "\n";
}
void 
GAErr(const char *clss, const char *func,
      const GAErrorIndex i, const char *msg2, const char *msg3){
  cerr << clss << ":\n  " << func << ": " << gaErrStr[i] << "\n";
  if(msg2) cerr << "  " << msg2 << "\n";
  if(msg3) cerr << "  " << msg3 << "\n";
}
void 
GAErr(const char *func, const GAErrorIndex i,
      const char *msg2, const char *msg3){
  cerr << func << ": " << gaErrStr[i] << "\n";
  if(msg2) cerr << "  " << msg2 << "\n";
  if(msg3) cerr << "  " << msg3 << "\n";
}
