// $Header: /usr/people/mbwall/src/ga/ga/RCS/error.h,v 1.4 1995/09/13 22:30:10 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  error.h
  mbwall 7may95
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
  This defines the error object and routines for handling errors.

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#ifndef _ga_error_h_
#define _ga_error_h_

#include <iostream.h>


// These are the indices for all of the error messages used in the library.
enum GAErrorIndex {
// general errors
  gaErrReadError=0,
  gaErrWriteError,
  gaErrUnexpectedEOF,
  gaErrBadProbValue,
  gaErrObjectTypeMismatch,

// errors for the GA objects
  gaErrWarnNoReplacement,
  gaErrNeedRS,
  gaErrBadRS,
  gaErrBadCS,
  gaErrNoIndGenerated,

// errors for the genome and crossover site objects
  gaErrParentSizeMismatch,
  gaErrChildSizeMismatch,
  gaErrFixedOnly,
  gaErrBadResizeBehaviour,
  gaErrBadPhenotypeID,
  gaErrBadPhenotypeValue,
  gaErrNoInitOp,
  gaErrNoMutOp,
  gaErrNoCrossOp,
  gaErrNoEqualOp,
  gaErrNoNotEqualOp,
  gaErrNoReadOp,
  gaErrNoWriteOp,
  gaErrNoCloneContOp,
  gaErrNoCloneAttrOp,
  gaErrNoPickOp,
  gaErrNoMirrorOp,

// scaling scheme error messages
  gaErrBadLinearScalingMult,
  gaErrBadSigmaTruncationMult,
  gaErrNegFitness,
  gaErrPowerNegFitness,

  gaErrBinStrTooLong,
  gaErrDataLost
};



// Error messages will look like this:
//
// GASimpleGA:
//   function: this is the error message
//
// GAGenome:
//   function: primary error message
//   additional error messages go here
//

extern char *gaErrStr[];

void GAErr(const char *clss, const char *func,
	   const char *msg1, const char *msg2=0, const char *msg3=0);
void GAErr(const char *clss, const char *func,
	   const GAErrorIndex i, const char *msg2=0, const char *msg3=0);
void GAErr(const char *func,
	   const GAErrorIndex i, const char *msg2=0, const char *msg3=0);


#endif
