// $Header: /usr/people/mbwall/src/ga/ga/RCS/list.ch.h,v 1.7 1995/09/13 22:30:10 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  list.ch.h
  mbwall 25feb95
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
  This header defines the interface for the list genome.

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#ifndef _ga_list_ch_h_
#define _ga_list_ch_h_

#include <ga/listtmpl.h>
#include <ga/genome.h>
#include <ga/list.xs.h>


/* ----------------------------------------------------------------------------
ListGenome
-------------------------------------------------------------------------------
---------------------------------------------------------------------------- */
template <class T>
class GAListGenome : public GAGenome, public GAList<T> {
  GADefineIdentity("GAListGenome", 55):

public:
  GAListGenome(GAObjectiveFunction f=0, void * u=(void *)0, GA * g=(GA *)0);
  GAListGenome(const GAListGenome<T> &);
  GAListGenome<T> & operator=(const GAListGenome<T> & orig)
    {copy(orig); return *this;}
  GAListGenome<T> & operator=(const GAGenome & orig)
    {copy(orig); return *this;}
  virtual ~GAListGenome(){}
  virtual GAGenome *clone(const GACloneMethod flag=gaCloneContents) const {
    GAListGenome<T> *cpy = new GAListGenome<T>(of,ud,ga);
    if(flag == gaCloneContents){cpy->copy(*this);}
    else{cpy->GAGenome::copy(*this);}
    return cpy;
  }
  virtual void copy(const GAGenome &);

  friend ostream & operator<<(ostream & os, const GAListGenome<T> & arg)
    {arg._write(os); return os;}
  friend istream & operator>>(istream & is, GAListGenome<T> & arg)
    {arg._read(is); return is;}
  friend int operator==(const GAListGenome<T> & a,
			const GAListGenome<T> & b)
    {return a._equal(b);}
  friend int operator!=(const GAListGenome<T> & a,
			const GAListGenome<T> & b)
    {return a._notequal(b);}

protected:
  void _write (ostream & os=cout) const;
  int _equal(const GAGenome & c) const;
  int _notequal(const GAGenome & c) const;
};

#ifdef BORLAND_INST
#include <ga/list.ch.C>
#endif

#endif
