// $Header: /usr/people/mbwall/src/ga/ga/RCS/string.ch.C,v 1.7 1995/09/13 22:30:10 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  string.ch.C
  mbwall 21mar95
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
   Source file for the string specialization of the array genome.

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#include <ga/config.h>
#include <ga/string.ch.h>
#include <ga/string.op.h>

#ifdef NO_AUTO_INST
#include <ga/array1.ch.C>
#include <ga/array1.xs.C>
template class GAArray<char>;
template class GA1DArrayGenome<char>;
#if USE_1PT_CROSSOVER == 1
template class GA1DArray1PtCrossSite<char>;
#endif
#if USE_2PT_CROSSOVER == 1
template class GA1DArray2PtCrossSite<char>;
#endif
#if USE_PARTIAL_MATCH_CROSSOVER == 1 || \
    USE_ORDER_CROSSOVER == 1 || \
    USE_CYCLE_CROSSOVER == 1
template class GA1DArrayOrderedCrossSite<char>;
#endif
#endif


/* ----------------------------------------------------------------------------
StringGenome
-------------------------------------------------------------------------------
  These are instantiated in the library so that you users don't have to do any
fancy instantiation - they can use the class as-is.
---------------------------------------------------------------------------- */
static DEFAULT_STRING_CROSSSITE gaStringDefCrossSite;

GA1DArrayGenome<char>::
GA1DArrayGenome(const unsigned int length, 
		GAAlleleSet<char> & s,
		GAObjectiveFunction f,
		void * u,
		GA * g) :
GAGenome(DEFAULT_STRING_INITIALIZER,
	 DEFAULT_STRING_MUTATOR,
	 DEFAULT_STRING_CROSSOVER,
	 &gaStringDefCrossSite),
GAArray<char>(length)
{
  of=f; ud=u; ga=g; as=&s;
  nx=minX=maxX=length;
}
