// $Header: /usr/people/mbwall/src/ga/ga/RCS/string.op.C,v 1.6 1995/09/13 22:30:10 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  string.op.C
  mbwall 21mar95
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
   Source file for the built-in operators for the string genome.  All of 
these methods are specializations of the routines in the array operators
source file.  All we do is include the operators already defined for arrays.
We redefine the names so that we don't get conflicts.
   Any string specializations of operators should be done here as well (this 
could lead to naming conflicts - beware of how you do it!)
   Notice that we must redefine ALL of the operators in array.op.C otherwise
users will get "mutliply defined" warnings when they try to include array.op.C
elsewhere in their code (should they be using strings and arrays in the same
code chunk, that is).

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#define GA1DArrayRandomInitializer     GAStringRandomInitializer
#define GA1DArrayOrderedInitializer    GAStringOrderedInitializer

#define GA1DArrayFlipMutator           GAStringFlipMutator
#define GA1DArraySwapMutator           GAStringSwapMutator

#define GA1DArray1PtCrossover          GAString1PtCrossover
#define GA1DArray2PtCrossover          GAString2PtCrossover
#define GA1DArrayEvenCrossover         GAStringEvenCrossover
#define GA1DArrayOddCrossover          GAStringOddCrossover
#define GA1DArrayPartialMatchCrossover GAStringPartialMatchCrossover
#define GA1DArrayOrderCrossover        GAStringOrderCrossover
#define GA1DArrayCycleCrossover        GAStringCycleCrossover
#define GA1DArrayUniformCrossover      GAStringUniformCrossover

#define ARRAY_TYPE char
#include <ga/array1.op.h>
