// $Header: /usr/people/mbwall/src/ga/ga/RCS/tree.ch.h,v 1.6 1995/07/11 20:35:22 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  tree.ch.h
  mbwall 25feb95
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
  This header defines the interface for the tree genome.

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#ifndef _ga_tree_ch_h_
#define _ga_tree_ch_h_

#include <ga/treetmpl.h>
#include <ga/genome.h>
#include <ga/tree.xs.h>


/* ----------------------------------------------------------------------------
TreeGenome
-------------------------------------------------------------------------------
  Beware that the tree genome can grow unbounded - there is no size limit
on the tree, so if you have an objective function that encourages size the tree
will grow until you run out of memory.
---------------------------------------------------------------------------- */
template <class T>
class GATreeGenome : public GAGenome, public GATree<T> {
  GADefineIdentity("GATreeGenome", 56):

public:
  GATreeGenome(GAObjectiveFunction f=NULL, void * u=NULL, GA * g=NULL);
  GATreeGenome(const GATreeGenome<T> &);
  GATreeGenome<T> & operator=(const GATreeGenome<T> & orig)
    {copy(orig); return *this;}
  GATreeGenome<T> & operator=(const GAGenome & orig)
    {copy(orig); return *this;}
  virtual ~GATreeGenome(){}
  virtual GAGenome *clone(const GACloneMethod flag=gaCloneContents) const {
    GATreeGenome<T> *cpy = new GATreeGenome<T>(of,ud,ga);
    if(flag == gaCloneContents){cpy->copy(*this);}
    else{cpy->GAGenome::copy(*this);}
    return cpy;
  }
  virtual void copy(const GAGenome &);

  friend ostream & operator<<(ostream & os, const GATreeGenome<T> & arg)
    {arg._write(os); return os;}
  friend istream & operator>>(istream & is, GATreeGenome<T> & arg)
    {arg._read(is); return is;}
  friend int operator==(const GATreeGenome<T> & a,
			const GATreeGenome<T> & b)
    {return a._equal(b);}
  friend int operator!=(const GATreeGenome<T> & a,
			const GATreeGenome<T> & b)
    {return a._notequal(b);}

protected:
  void _write (ostream & os=cout) const;
  int _equal(const GAGenome & c) const;
  int _notequal(const GAGenome & c) const;
};

#ifdef BORLAND_INST
#include <ga/tree.ch.C>
#endif

#endif
