// $Header: /usr/people/mbwall/src/ga/ga/RCS/tree.xs.h,v 1.6 1995/07/11 20:35:22 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  tree.xs.h
  mbwall 25feb95
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
  This header defines the interface for the tree genome crossover sites.

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#ifndef _ga_tree_xs_h_
#define _ga_tree_xs_h_

#include <ga/xsite.h>


/* ----------------------------------------------------------------------------
 Tree Single Point Sub-Tree-Swap Crossover (one point in each parent)
---------------------------------------------------------------------------- */
template <class T>
class GATree1PtCrossSite : public GACrossSite {
  GADefineIdentity("GATree1PtCrossSite", 97):

public:
  GATree1PtCrossSite(){a=gaNoSite; b=gaNoSite;}
  GATree1PtCrossSite(int x, int y){a=x; b=y;}
  GATree1PtCrossSite(const GATree1PtCrossSite & orig){copy(orig);}
  GATree1PtCrossSite<T> & operator=(const GACrossSite & orig)
    {copy(orig); return *this;}
  GATree1PtCrossSite<T> & operator=(const GATree1PtCrossSite<T> & orig)
    {copy(orig); return *this;}
  virtual ~GATree1PtCrossSite(){}
  virtual void copy(const GACrossSite & xs){
    if(&xs == this || !sameClass(xs)) return;
    GATree1PtCrossSite<T> & orig = (GATree1PtCrossSite<T> &)xs;
    a=orig.a; b=orig.b;
  }
  virtual GACrossSite * clone() const
    {return new GATree1PtCrossSite<T>(*this);}

  virtual void pick(GAGenome &);
  virtual void pick(GAGenome &, const GACrossSite & s){copy(s);}
  virtual void pick(GAGenome &,const GAGenome&, const GAGenome&);
  virtual void mirror(GAGenome &, const GAGenome &);
  int a, b;
};

#ifdef BORLAND_INST
#include <ga/tree.xs.C>
#endif

#endif
