// $Header: /usr/people/mbwall/src/ga/ga/RCS/genome.C,v 1.3 1995/09/13 22:30:10 mbwall Exp mbwall $
/* ----------------------------------------------------------------------------
  genome.C
  mbwall 19apr95
  Copyright 1995 Massachusetts Institute of Technology

 DESCRIPTION:
  Definitions for genome base class.

 TO DO:

 MODIFICATIONS:
---------------------------------------------------------------------------- */
#include <ga/genome.h>


//   These are the default crossover, mutation, and initialization methods.  
// None does anything - they just post an error message to let you know that no
// method has been defined.  These are for the base class (which has no 
// function by itself). 
void GANoInitializer(GAGenome & c){ 
  GAErr(c.className(), "GANoIntializer", gaErrNoInitOp); 
}
int GANoMutator(GAGenome & c, float){ 
  GAErr(c.className(), "GANoMutator", gaErrNoMutOp); return 0; 
}
void GANoCrossover(GAGenome & c, const GAGenome&, const GAGenome&){
  GAErr(c.className(), "GANoCrossover", gaErrNoCrossOp); 
}





GAGenome::GAGenome(GAInitializationOperator i,
			   GAMutationOperator m,
			   GACrossoverOperator c,
			   GACrossSite * s,
			   GAObjectiveVector * o){
  _score=0.0; _evaluated=gaFalse; _nmut=0;
  ga=0; ud=0; of=0;
  io=i; mo=m; co=c;
  if(s){cs=s->clone();}
  else{cs=new GACrossSite;}
  if(o){ov=o->clone();}
  else{ov=0;}
}

GAGenome::GAGenome(const GAGenome & orig){
  ga=0; ud=0; of=0;
  cs=0; ov=0;
  copy(orig);
}

void
GAGenome::copy(const GAGenome & orig){
  if(&orig == this) return;
  _score=orig._score; _evaluated=orig._evaluated; _nmut=orig._nmut;
  ga=orig.ga; ud=orig.ud; of=orig.of;
  co=orig.co; mo=orig.mo; io=orig.io;
  if(cs->sameClass(*orig.cs)){cs->copy(*orig.cs);}
  else{delete cs; cs=orig.cs->clone();}
  if(orig.ov){
    if(ov) ov->copy(*orig.ov);
    else ov = orig.ov->clone();
  }				// don't delete if c doesn't have one
}
